<?php 
/**
 * This class is used for creating paging
 */ 
class Pager
{
  var $total; // Total number of items
  var $limit; // Number of items per page
  var $page; // The page number
  var $numPages;
  var $offset;
  
  function __construct($total, $limit, $page) {
    $this->init($total, $limit, $page);
  }
  
  function Pager($total, $limit, $page) {
    $this->init($total, $limit, $page);
  }

	function init($total, $limit, $page)  
	{  
		$this->total  = (int) $total;  //Total number of items
		$this->limit    = max((int) $limit, 1);  //Items per page
		$this->page     = (int) $page;  //Page Number
		$this->numPages = ceil($total / $limit);  
		
		$this->page = max($page, 1);  
		$this->page = min($page, $numPages);  
		
		$this->offset = ($page - 1) * $limit;
	}
  
  function getTotal() {
    return $this->total;
  }
  
  function setTotal($total) {
    $this->total = $total;
  }
  
  function getLimit() {
    return $this->limit;
  }
  
  function setLimit($limit) {
    $this->limit = $limit;
  }
  
  function getPage() {
    return $this->page;
  }
  
  function setPage($page) {
    $this->page = $page;
  }
  
  function getNumPages() {
    return $this->numPages;
  }
  
  function setNumPages($numPages) {
    $this->numPages = $numPages;
  }
  
  function getOffset() {
    return $this->offset;
  }
  
  function setOffset($offset) {
    $this->offset = $offset;
  }
}
?>
